## orthanc-python 1.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(OrthancPython)

set(PLUGIN_VERSION "1.0")


set(PYTHON_VERSION "3.6" CACHE STRING "Version of Python to be used")
set(PYTHON_WINDOWS_ROOT "" CACHE STRING "")
set(USE_SYSTEM_BOOST ON CACHE BOOL "Use the system version of Boost")
set(USE_SYSTEM_JSONCPP ON CACHE BOOL "Use the system version of JsonCpp")
set(USE_LEGACY_JSONCPP OFF CACHE BOOL "Use the old branch 0.x.y of JsonCpp, that does not require a C++11 compiler (for LSB and old versions of Visual Studio)")

include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(FindPythonInterp)

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  set(PYTHON_INCLUDE_DIRS ${PYTHON_WINDOWS_ROOT}/include)
  set(PYTHON_LIBRARIES ${PYTHON_WINDOWS_ROOT}/libs/libpython27.a)
  
else()
  find_package(PkgConfig REQUIRED)
  pkg_check_modules(PYTHON_1 python-${PYTHON_VERSION}-embed)

  if (PYTHON_1_FOUND)
    set(PYTHON_INCLUDE_DIRS ${PYTHON_1_INCLUDE_DIRS})
    set(PYTHON_LIBRARIES ${PYTHON_1_LIBRARIES})
  else()
    pkg_check_modules(PYTHON_2 REQUIRED python-${PYTHON_VERSION})
    set(PYTHON_INCLUDE_DIRS ${PYTHON_2_INCLUDE_DIRS})
    set(PYTHON_LIBRARIES ${PYTHON_2_LIBRARIES})
  endif()
endif()

set(ORTHANC_ROOT ${CMAKE_SOURCE_DIR}/Resources/Orthanc)
include(${ORTHANC_ROOT}/Resources/CMake/Compiler.cmake)
include(${ORTHANC_ROOT}/Resources/CMake/DownloadPackage.cmake)
include(${ORTHANC_ROOT}/Resources/CMake/BoostConfiguration.cmake)
include(${ORTHANC_ROOT}/Resources/CMake/JsonCppConfiguration.cmake)


if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  execute_process(
    COMMAND 
    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
    ${PLUGIN_VERSION} "Python plugin" OrthancPython.dll
    "Plugin to create Orthanc plugins using Python"
    ERROR_VARIABLE Failure
    OUTPUT_FILE ${CMAKE_CURRENT_BINARY_DIR}/Version.rc
    )

  if (Failure)
    message(FATAL_ERROR "Error while computing the version information: ${Failure}")
  endif()

  set(WINDOWS_RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/Version.rc)
endif()


include_directories(
  ${ORTHANC_ROOT}/Sdk-1.5.7
  )

add_definitions(
  -DHAS_ORTHANC_EXCEPTION=0
  )

include_directories(
  ${ORTHANC_ROOT}/Plugins/Samples/Common
  ${PYTHON_INCLUDE_DIRS}
  )

add_library(OrthancPython SHARED
  ${BOOST_SOURCES}
  ${JSONCPP_SOURCES}
  ${ORTHANC_ROOT}/Plugins/Samples/Common/OrthancPluginCppWrapper.cpp
  ${WINDOWS_RESOURCES}
  Sources/Autogenerated/sdk.cpp
  Sources/OnChangeCallback.cpp
  Sources/OnStoredInstanceCallback.cpp
  Sources/Plugin.cpp
  Sources/PythonFunction.cpp
  Sources/PythonLock.cpp
  Sources/PythonModule.cpp
  Sources/PythonObject.cpp
  Sources/PythonString.cpp
  Sources/RestCallbacks.cpp
  )

target_link_libraries(OrthancPython ${PYTHON_LIBRARIES})

add_definitions(-DPLUGIN_VERSION="${PLUGIN_VERSION}")

set_target_properties(OrthancPython PROPERTIES 
  VERSION ${PLUGIN_VERSION} 
  SOVERSION ${PLUGIN_VERSION}
  )

install(
  TARGETS OrthancPython
  RUNTIME DESTINATION lib    # Destination for Windows
  LIBRARY DESTINATION share/orthanc/plugins    # Destination for Linux
  )

=== debian/changelog ===
orthanc-python (1.0+ds-2build2) groovy; urgency=medium

  * No-change rebuild against libboost-regex1.71.0-icu67

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 28 Jul 2020 19:23:51 +0000

orthanc-python (1.0+ds-2build1) groovy; urgency=medium

  * No change rebuild against new icu ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 27 Jul 2020 16:44:20 +0100

orthanc-python (1.0+ds-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 12 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Andreas Tille <tille@debian.org>  Sat, 18 Apr 2020 08:23:02 +0200

orthanc-python (1.0+ds-1) unstable; urgency=medium

  [ Sebastien Jodogne ]
  * Initial release. (Closes: #955495)

 -- Alexandre Mestiashvili <mestia@debian.org>  Fri, 03 Apr 2020 22:28:20 +0200

=== debian/control ===
Source: orthanc-python
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               libboost-all-dev,
               libjsoncpp-dev,
               libpython3-dev,
               python3-dev,
               pkg-config,
               unzip
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/orthanc-python
Vcs-Git: https://salsa.debian.org/med-team/orthanc-python.git
Homepage: https://book.orthanc-server.com/plugins/python.html
Rules-Requires-Root: no

Package: orthanc-python
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         orthanc (>= 1.5.7)
Suggests: python3
Description: Develop plugins for Orthanc using the Python programming language
 This plugin can be used to write Orthanc plugins using the Python programming
 language instead of the more complex C/C++ programming languages. It can be
 used to gain access to Python modules directly in Orthanc.
 .
 This plugin can be of great help to anyone wishing to automate her imaging
 workflow, to design/train new machine learning algorithms, or to deploy AI
 systems directly in clinical setups.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk   # To access the "DEB_VERSION" variable

export UPSTREAM_VERSION := $(shell echo "$(DEB_VERSION)" | cut -d '+' -f 1)
export PYTHON_VERSION := $(shell pkg-config python3 --modversion)
export TARGET := libOrthancPython.so

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

# Disable assert() checking from upstream project, for best performance
# https://lists.debian.org/debian-med/2018/04/msg00132.html
export DEB_CFLAGS_MAINT_APPEND=-DNDEBUG
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ --builddirectory=Build

CMAKE_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DSTATIC_BUILD:BOOL=OFF \
        -DDEB_VERSION=$(DEB_VERSION) \
        -DPYTHON_VERSION=$(PYTHON_VERSION) \
        -DCMAKE_BUILD_TYPE=None  # The build type must be set to None, see #711515

override_dh_auto_configure:
	mkdir Build
	dh_auto_configure --builddirectory=Build -- $(CMAKE_EXTRA_FLAGS)

override_dh_clean:
	dh_clean

override_dh_auto_install:
	dh_install Build/${TARGET}.${UPSTREAM_VERSION} usr/lib/orthanc

override_dh_link:
	dh_link usr/lib/orthanc/${TARGET}.${UPSTREAM_VERSION} \
		usr/share/orthanc/plugins/${TARGET}

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS

## orthanc-python 3.1%2Bds

=== debian/changelog ===
orthanc-python (3.1+ds-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 22 Jan 2021 10:57:34 +0100

orthanc-python (3.0+ds-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 09 Dec 2020 18:14:23 +0100

orthanc-python (2.0+ds-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sat, 17 Oct 2020 17:55:27 +0200

## orthanc-python 3.1+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(OrthancPython)

set(PLUGIN_VERSION "3.1")

if (PLUGIN_VERSION STREQUAL "mainline")
  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "mainline")
  set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
else()
  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.8.2")
  set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
endif()


if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
  # The Python version cannot be controlled on OS X (yet)
  set(PYTHON_VERSION "3.6" CACHE STRING "Version of Python to be used")
endif()

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  # Windows-specific options
  set(PYTHON_WINDOWS_ROOT "" CACHE STRING "")
  set(PYTHON_LIBRARY_NAME "" CACHE STRING "")
  set(PYTHON_WINDOWS_USE_RELEASE_LIBS ON CACHE BOOL "Use the release Python libraries when building with Microsoft Visual Studio, even when compiling in _DEBUG mode (set it to OFF if you require linking to a Python debug build)")
endif()



# Parameters of the build
set(STATIC_BUILD OFF CACHE BOOL "Static build of the third-party libraries (necessary for Windows)")
set(ALLOW_DOWNLOADS OFF CACHE BOOL "Allow CMake to download packages")
set(ORTHANC_FRAMEWORK_SOURCE "${ORTHANC_FRAMEWORK_DEFAULT_SOURCE}" CACHE STRING "Source of the Orthanc framework (can be \"system\", \"hg\", \"archive\", \"web\" or \"path\")")
set(ORTHANC_FRAMEWORK_VERSION "${ORTHANC_FRAMEWORK_DEFAULT_VERSION}" CACHE STRING "Version of the Orthanc framework")
set(ORTHANC_FRAMEWORK_ARCHIVE "" CACHE STRING "Path to the Orthanc archive, if ORTHANC_FRAMEWORK_SOURCE is \"archive\"")
set(ORTHANC_FRAMEWORK_ROOT "" CACHE STRING "Path to the Orthanc source directory, if ORTHANC_FRAMEWORK_SOURCE is \"path\"")

# Advanced parameters to fine-tune linking against system libraries
set(USE_SYSTEM_ORTHANC_SDK ON CACHE BOOL "Use the system version of the Orthanc plugin SDK")
set(ORTHANC_FRAMEWORK_STATIC OFF CACHE BOOL "If linking against the Orthanc framework system library, indicates whether this library was statically linked")
mark_as_advanced(ORTHANC_FRAMEWORK_STATIC)


# Download and setup the Orthanc framework
include(${CMAKE_SOURCE_DIR}/Resources/Orthanc/CMake/DownloadOrthancFramework.cmake)

include_directories(${ORTHANC_FRAMEWORK_ROOT})

if (ORTHANC_FRAMEWORK_SOURCE STREQUAL "system")
  #link_libraries(${ORTHANC_FRAMEWORK_LIBRARIES})

else()
  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkParameters.cmake)
  
  #set(ENABLE_MODULE_IMAGES OFF CACHE INTERNAL "")
  #set(ENABLE_MODULE_JOBS OFF CACHE INTERNAL "")
  #set(ENABLE_MODULE_DICOM OFF CACHE INTERNAL "")
  
  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkConfiguration.cmake)
endif()


include(${CMAKE_SOURCE_DIR}/Resources/Orthanc/Plugins/OrthancPluginsExports.cmake)


include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(FindPythonInterp)


if (${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
  find_package(PythonLibs)
  if (NOT PYTHONLIBS_FOUND)
    message(FATAL_ERROR "Cannot find the Python libraries")
  endif()

  message("Python library - Found version: ${PYTHONLIBS_VERSION_STRING}")
  message("Python library - Path to include directory: ${PYTHON_INCLUDE_DIRS}")
  message("Python library - Shared library: ${PYTHON_LIBRARIES}")

else()
  string(REGEX REPLACE "^([0-9]*)\\.([0-9]*)$" "\\1" PYTHON_VERSION_MAJOR ${PYTHON_VERSION})
  string(REGEX REPLACE "^([0-9]*)\\.([0-9]*)$" "\\2" PYTHON_VERSION_MINOR ${PYTHON_VERSION})

  if (NOT PYTHON_VERSION STREQUAL
      "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
    message(FATAL_ERROR "Error in the (x.y) format of the Python version: ${PYTHON_VERSION}")
  endif()

  if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    if ("${PYTHON_LIBRARY_NAME}" STREQUAL "")
      if (MSVC)
        set(Prefix "")
        set(Suffix ".lib")
        if(PYTHON_WINDOWS_USE_RELEASE_LIBS)
          add_definitions(-DORTHANC_PYTHON_WINDOWS_USE_RELEASE_LIBS=1)
        endif()
      else()
        list(GET CMAKE_FIND_LIBRARY_PREFIXES 0 Prefix)
        set(Suffix ".a")
      endif()
      
      set(PYTHON_LIBRARY_NAME ${Prefix}python${PYTHON_VERSION_MAJOR}${PYTHON_VERSION_MINOR}${Suffix})
    endif()
    
    if (CMAKE_COMPILER_IS_GNUCXX AND
        "${CMAKE_SIZEOF_VOID_P}" STREQUAL "8" AND
        "${PYTHON_VERSION}" STREQUAL "2.7")
      # Fix for MinGW 64bit: https://stackoverflow.com/a/19867426/881731
      add_definitions(-DMS_WIN64)
    endif()
    
    set(PYTHON_INCLUDE_DIRS ${PYTHON_WINDOWS_ROOT}/include)
    set(PYTHON_LIBRARIES ${PYTHON_WINDOWS_ROOT}/libs/${PYTHON_LIBRARY_NAME})
    
    execute_process(
      COMMAND 
      ${PYTHON_EXECUTABLE} ${ORTHANC_FRAMEWORK_ROOT}/../Resources/WindowsResources.py
      ${PLUGIN_VERSION} "Python plugin" OrthancPython.dll
      "Plugin to create Orthanc plugins using Python"
      ERROR_VARIABLE Failure
      OUTPUT_FILE ${CMAKE_CURRENT_BINARY_DIR}/Version.rc
      )

    if (Failure)
      message(FATAL_ERROR "Error while computing the version information: ${Failure}")
    endif()

    set(WINDOWS_RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/Version.rc)

  else()
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(PYTHON_1 python-${PYTHON_VERSION}-embed)

    if (PYTHON_1_FOUND)
      set(PYTHON_INCLUDE_DIRS ${PYTHON_1_INCLUDE_DIRS})
      set(PYTHON_LIBRARIES ${PYTHON_1_LIBRARIES})
    else()
      pkg_check_modules(PYTHON_2 REQUIRED python-${PYTHON_VERSION})
      set(PYTHON_INCLUDE_DIRS ${PYTHON_2_INCLUDE_DIRS})
      set(PYTHON_LIBRARIES ${PYTHON_2_LIBRARIES})
    endif()
  endif()
endif()


include_directories(
  ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Sdk-1.8.1
  )

add_definitions(
  -DHAS_ORTHANC_EXCEPTION=0
  )

include_directories(
  ${PYTHON_INCLUDE_DIRS}
  )

add_library(OrthancPython SHARED
  Sources/Autogenerated/sdk.cpp
  Sources/IncomingHttpRequestFilter.cpp
  Sources/OnChangeCallback.cpp
  Sources/OnStoredInstanceCallback.cpp
  Sources/Plugin.cpp
  Sources/PythonFunction.cpp
  Sources/PythonLock.cpp
  Sources/PythonModule.cpp
  Sources/PythonObject.cpp
  Sources/PythonString.cpp
  Sources/RestCallbacks.cpp

  # Third-party sources
  ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Plugins/OrthancPluginCppWrapper.cpp
  ${BOOST_SOURCES}
  ${JSONCPP_SOURCES}
  ${WINDOWS_RESOURCES}
  )

target_link_libraries(OrthancPython ${PYTHON_LIBRARIES})

add_definitions(-DPLUGIN_VERSION="${PLUGIN_VERSION}")

set_target_properties(OrthancPython PROPERTIES 
  VERSION ${PLUGIN_VERSION} 
  SOVERSION ${PLUGIN_VERSION}
  )

install(
  TARGETS OrthancPython
  RUNTIME DESTINATION lib    # Destination for Windows
  LIBRARY DESTINATION share/orthanc/plugins    # Destination for Linux
  )

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: orthanc-python
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>
 Section: science
 Priority: optional
@@ -8,11 +7,12 @@
                debhelper-compat (= 12),
                libboost-all-dev,
                libjsoncpp-dev,
+               liborthancframework-dev,
                libpython3-dev,
                python3-dev,
                pkg-config,
                unzip
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-python
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-python.git
 Homepage: https://book.orthanc-server.com/plugins/python.html
@@ -22,7 +22,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         orthanc (>= 1.5.7)
+         orthanc (>= 1.8.1)
 Suggests: python3
 Description: Develop plugins for Orthanc using the Python programming language
  This plugin can be used to write Orthanc plugins using the Python programming

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,7 @@
 	-DSTATIC_BUILD:BOOL=OFF \
         -DDEB_VERSION=$(DEB_VERSION) \
         -DPYTHON_VERSION=$(PYTHON_VERSION) \
+        -DORTHANC_FRAMEWORK_SOURCE=system \
         -DCMAKE_BUILD_TYPE=None  # The build type must be set to None, see #711515
 
 override_dh_auto_configure:

## orthanc-python 3.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,13 @@
 cmake_minimum_required(VERSION 2.8)
 project(OrthancPython)
 
-set(PLUGIN_VERSION "3.1")
+set(PLUGIN_VERSION "3.4")
 
 if (PLUGIN_VERSION STREQUAL "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
 else()
-  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.8.2")
+  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.9.7")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
 endif()
 
@@ -43,10 +43,15 @@
 # Download and setup the Orthanc framework
 include(${CMAKE_SOURCE_DIR}/Resources/Orthanc/CMake/DownloadOrthancFramework.cmake)
 
-include_directories(${ORTHANC_FRAMEWORK_ROOT})
-
 if (ORTHANC_FRAMEWORK_SOURCE STREQUAL "system")
-  #link_libraries(${ORTHANC_FRAMEWORK_LIBRARIES})
+  include(FindBoost)
+  find_package(Boost COMPONENTS filesystem regex thread)
+
+  if (NOT Boost_FOUND)
+    message(FATAL_ERROR "Unable to locate Boost on this system")
+  endif()
+
+  link_libraries(${Boost_LIBRARIES} jsoncpp)
 
 else()
   include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkParameters.cmake)
@@ -56,6 +61,7 @@
   #set(ENABLE_MODULE_DICOM OFF CACHE INTERNAL "")
   
   include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkConfiguration.cmake)
+  include_directories(${ORTHANC_FRAMEWORK_ROOT})
 endif()
 
 
@@ -159,6 +165,8 @@
 
 add_library(OrthancPython SHARED
   Sources/Autogenerated/sdk.cpp
+  Sources/DicomScpCallbacks.cpp
+  Sources/ICallbackRegistration.cpp
   Sources/IncomingHttpRequestFilter.cpp
   Sources/OnChangeCallback.cpp
   Sources/OnStoredInstanceCallback.cpp
@@ -169,6 +177,7 @@
   Sources/PythonObject.cpp
   Sources/PythonString.cpp
   Sources/RestCallbacks.cpp
+  Sources/StorageArea.cpp
 
   # Third-party sources
   ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Plugins/OrthancPluginCppWrapper.cpp

=== debian/changelog ===
orthanc-python (3.4+ds-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 01 Sep 2021 15:55:00 +0200

orthanc-python (3.3+ds-1) experimental; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 12 Aug 2021 20:55:31 +0200

orthanc-python (3.2+ds-2) experimental; urgency=medium

  * Added missing "Built-Using" attribute

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 08 Jul 2021 16:30:09 +0200

orthanc-python (3.2+ds-1) experimental; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 08 Jul 2021 15:41:37 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                python3-dev,
                pkg-config,
                unzip
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-python
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-python.git
 Homepage: https://book.orthanc-server.com/plugins/python.html
@@ -23,6 +23,7 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          orthanc (>= 1.8.1)
+Built-Using: ${orthancframework:Built-Using}
 Suggests: python3
 Description: Develop plugins for Orthanc using the Python programming language
  This plugin can be used to write Orthanc plugins using the Python programming

## orthanc-python 4.0%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,13 @@
 cmake_minimum_required(VERSION 2.8)
 project(OrthancPython)
 
-set(PLUGIN_VERSION "3.4")
+set(PLUGIN_VERSION "4.0")
 
 if (PLUGIN_VERSION STREQUAL "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
 else()
-  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.9.7")
+  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.10.0")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
 endif()
 
@@ -33,9 +33,9 @@
 set(ORTHANC_FRAMEWORK_VERSION "${ORTHANC_FRAMEWORK_DEFAULT_VERSION}" CACHE STRING "Version of the Orthanc framework")
 set(ORTHANC_FRAMEWORK_ARCHIVE "" CACHE STRING "Path to the Orthanc archive, if ORTHANC_FRAMEWORK_SOURCE is \"archive\"")
 set(ORTHANC_FRAMEWORK_ROOT "" CACHE STRING "Path to the Orthanc source directory, if ORTHANC_FRAMEWORK_SOURCE is \"path\"")
+set(USE_FRAMEWORK_ORTHANC_SDK OFF CACHE BOOL "Whether to use the SDK from the Orthanc sources (for developers only, to support new features of the SDK that are still pending in the mainline)")
 
 # Advanced parameters to fine-tune linking against system libraries
-set(USE_SYSTEM_ORTHANC_SDK ON CACHE BOOL "Use the system version of the Orthanc plugin SDK")
 set(ORTHANC_FRAMEWORK_STATIC OFF CACHE BOOL "If linking against the Orthanc framework system library, indicates whether this library was statically linked")
 mark_as_advanced(ORTHANC_FRAMEWORK_STATIC)
 
@@ -151,9 +151,15 @@
 endif()
 
 
-include_directories(
-  ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Sdk-1.8.1
-  )
+if (USE_FRAMEWORK_ORTHANC_SDK)
+  include_directories(
+    ${ORTHANC_FRAMEWORK_ROOT}/../../OrthancServer/Plugins/Include
+    )
+else()
+  include_directories(
+    ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Sdk-1.10.0
+    )
+endif()
 
 add_definitions(
   -DHAS_ORTHANC_EXCEPTION=0
@@ -168,6 +174,7 @@
   Sources/DicomScpCallbacks.cpp
   Sources/ICallbackRegistration.cpp
   Sources/IncomingHttpRequestFilter.cpp
+  Sources/IncomingInstanceFilter.cpp
   Sources/OnChangeCallback.cpp
   Sources/OnStoredInstanceCallback.cpp
   Sources/Plugin.cpp
@@ -176,6 +183,7 @@
   Sources/PythonModule.cpp
   Sources/PythonObject.cpp
   Sources/PythonString.cpp
+  Sources/ReceivedInstanceCallback.cpp
   Sources/RestCallbacks.cpp
   Sources/StorageArea.cpp

## orthanc-python 4.0+ds

=== debian/changelog ===
orthanc-python (4.0+ds-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 23 Feb 2022 20:33:19 +0100

orthanc-python (3.4+ds-2) unstable; urgency=medium

  * Replace explicit restart of Orthanc by orthanc-restart-trigger

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 16 Jan 2022 19:17:11 +0100

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         orthanc (>= 1.8.1)
+         orthanc (>= 1.10.0+dfsg-1)
 Built-Using: ${orthancframework:Built-Using}
 Suggests: python3
 Description: Develop plugins for Orthanc using the Python programming language

=== debian/watch ===
version=3
opts="repacksuffix=+ds,dversionmangle=s/\+ds//g,downloadurlmangle=s/\/browse\.php\?path=//g,repack,compression=xz" \
https://www.orthanc-server.com/browse.php?path=/plugin-python downloads/get\.php\?path=/plugin-python/OrthancPython-(\d\S*)\.tar\.gz

## orthanc-python 4.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,13 @@
 cmake_minimum_required(VERSION 2.8)
 project(OrthancPython)
 
-set(PLUGIN_VERSION "4.0")
+set(PLUGIN_VERSION "4.1")
 
 if (PLUGIN_VERSION STREQUAL "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
 else()
-  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.10.0")
+  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.12.1")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
 endif()
 
@@ -178,6 +178,7 @@
   Sources/OnChangeCallback.cpp
   Sources/OnStoredInstanceCallback.cpp
   Sources/Plugin.cpp
+  Sources/PythonBytes.cpp
   Sources/PythonFunction.cpp
   Sources/PythonLock.cpp
   Sources/PythonModule.cpp
@@ -186,6 +187,7 @@
   Sources/ReceivedInstanceCallback.cpp
   Sources/RestCallbacks.cpp
   Sources/StorageArea.cpp
+  Sources/StorageCommitmentScpCallback.cpp
 
   # Third-party sources
   ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Plugins/OrthancPluginCppWrapper.cpp

=== debian/changelog ===
orthanc-python (4.1+ds-2ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:07:37 +1100

orthanc-python (4.1+ds-2ubuntu1) noble; urgency=medium

  * Remove wrong hard-coded test dep on libcurl4.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 26 Mar 2024 08:14:13 +0000

orthanc-python (4.1+ds-2build3) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Mar 2024 21:14:35 +0100

orthanc-python (4.1+ds-2build2) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 20:36:50 +0000

orthanc-python (4.1+ds-2build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 20:44:37 +0100

orthanc-python (4.1+ds-2) unstable; urgency=medium

  * Team Upload.
  [ Oyindamola Olatunji ]
  * Attempt to add autopkgtest

  [ Nilesh Patra ]
  * Get autopkgtests working
  * Bump debhelper compatibility level to 13
  * Bump d/watch version to 4

 -- Nilesh Patra <nilesh@debian.org>  Wed, 08 Nov 2023 02:45:57 +0530

orthanc-python (4.1+ds-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 30 Aug 2023 15:39:16 +0200

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,20 @@
 Source: orthanc-python
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>
 Section: science
 Priority: optional
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libboost-all-dev,
                libjsoncpp-dev,
                liborthancframework-dev,
                libpython3-dev,
+               orthanc-dev,
                python3-dev,
                pkg-config,
                unzip
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-python
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-python.git
 Homepage: https://book.orthanc-server.com/plugins/python.html

=== debian/watch ===
version=4
opts="repacksuffix=+ds,dversionmangle=s/\+ds//g,downloadurlmangle=s/\/browse\.php\?path=//g,repack,compression=xz" \
https://www.orthanc-server.com/browse.php?path=/plugin-python downloads/get\.php\?path=/plugin-python/OrthancPython-(\d\S*)\.tar\.gz

## orthanc-python 4.3+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,37 @@
+# SPDX-FileCopyrightText: 2020-2023 Osimis S.A., 2024-2024 Orthanc Team SRL, 2021-2024 Sebastien Jodogne, ICTEAM UCLouvain
+# SPDX-License-Identifier: AGPL-3.0-or-later
+
+##
+## Python plugin for Orthanc
+## Copyright (C) 2020-2023 Osimis S.A., Belgium
+## Copyright (C) 2024-2024 Orthanc Team SRL, Belgium
+## Copyright (C) 2021-2024 Sebastien Jodogne, ICTEAM UCLouvain, Belgium
+##
+## This program is free software: you can redistribute it and/or
+## modify it under the terms of the GNU Affero General Public License
+## as published by the Free Software Foundation, either version 3 of
+## the License, or (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful, but
+## WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+## Affero General Public License for more details.
+##
+## You should have received a copy of the GNU Affero General Public License
+## along with this program. If not, see <http://www.gnu.org/licenses/>.
+##
+
+
 cmake_minimum_required(VERSION 2.8)
 project(OrthancPython)
 
-set(PLUGIN_VERSION "4.1")
+set(PLUGIN_VERSION "4.3")
 
 if (PLUGIN_VERSION STREQUAL "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
 else()
-  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.12.1")
+  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.12.4")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
 endif()
 
@@ -184,6 +208,7 @@
   Sources/PythonModule.cpp
   Sources/PythonObject.cpp
   Sources/PythonString.cpp
+  Sources/PythonThreadsAllower.cpp
   Sources/ReceivedInstanceCallback.cpp
   Sources/RestCallbacks.cpp
   Sources/StorageArea.cpp
@@ -196,17 +221,36 @@
   ${WINDOWS_RESOURCES}
   )
 
+if (CMAKE_COMPILER_IS_GNUCXX)
+  # Don't report warnings about deprecated functions in the Orthanc SDK
+  set_source_files_properties(
+    Sources/Autogenerated/sdk.cpp
+    PROPERTIES COMPILE_FLAGS -Wno-deprecated-declarations)
+endif()
+
 target_link_libraries(OrthancPython ${PYTHON_LIBRARIES})
 
-add_definitions(-DPLUGIN_VERSION="${PLUGIN_VERSION}")
+add_definitions(
+  -DPLUGIN_NAME="python"
+  -DPLUGIN_VERSION="${PLUGIN_VERSION}"
+  )
 
 set_target_properties(OrthancPython PROPERTIES 
   VERSION ${PLUGIN_VERSION} 
   SOVERSION ${PLUGIN_VERSION}
   )
+
+configure_file(
+  Sources/Autogenerated/orthanc.pyi
+  ${CMAKE_CURRENT_BINARY_DIR}/orthanc.pyi
+  COPYONLY)
 
 install(
   TARGETS OrthancPython
   RUNTIME DESTINATION lib    # Destination for Windows
   LIBRARY DESTINATION share/orthanc/plugins    # Destination for Linux
   )
+
+if (COMMAND DefineSourceBasenameForTarget)
+  DefineSourceBasenameForTarget(OrthancPython)
+endif()

=== debian/changelog ===
orthanc-python (4.3+ds-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 04 Jul 2024 10:09:37 +0200

orthanc-python (4.2+ds-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 22 May 2024 18:28:22 +0200

orthanc-python (4.1+ds-3) unstable; urgency=medium

  * autopkgtest: Fix the waiting for Orthanc to start. Closes: #1062404

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sat, 30 Mar 2024 14:06:27 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: orthanc-python
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>
 Section: science
 Priority: optional
@@ -12,12 +11,12 @@
                libpython3-dev,
                orthanc-dev,
                python3-dev,
-               pkg-config,
+               pkgconf,
                unzip
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-python
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-python.git
-Homepage: https://book.orthanc-server.com/plugins/python.html
+Homepage: https://orthanc.uclouvain.be/book/plugins/python.html
 Rules-Requires-Root: no
 
 Package: orthanc-python

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, python3, orthanc, curl, libcurl4, orthanc-python, procps
Restrictions: needs-sudo, allow-stderr, isolation-container

## orthanc-python 5.0%2Bds

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,13 @@
                debhelper-compat (= 13),
                libboost-all-dev,
                libjsoncpp-dev,
-               liborthancframework-dev,
+               liborthancframework-dev (>= 1.12.7+dfsg-3),
                libpython3-dev,
                orthanc-dev,
                python3-dev,
                pkgconf,
                unzip
-Standards-Version: 4.7.0
+Standards-Version: 4.7.1
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-python
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-python.git
 Homepage: https://orthanc.uclouvain.be/book/plugins/python.html
@@ -23,7 +23,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         orthanc (>= 1.10.0+dfsg-1)
+         orthanc (>= 1.12.7+dfsg-3)
 Built-Using: ${orthancframework:Built-Using}
 Suggests: python3
 Description: Develop plugins for Orthanc using the Python programming language

## orthanc-python 5.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-# SPDX-FileCopyrightText: 2020-2023 Osimis S.A., 2024-2024 Orthanc Team SRL, 2021-2024 Sebastien Jodogne, ICTEAM UCLouvain
+# SPDX-FileCopyrightText: 2020-2023 Osimis S.A., 2024-2025 Orthanc Team SRL, 2021-2025 Sebastien Jodogne, ICTEAM UCLouvain
 # SPDX-License-Identifier: AGPL-3.0-or-later
 
 ##
 ## Python plugin for Orthanc
 ## Copyright (C) 2020-2023 Osimis S.A., Belgium
-## Copyright (C) 2024-2024 Orthanc Team SRL, Belgium
-## Copyright (C) 2021-2024 Sebastien Jodogne, ICTEAM UCLouvain, Belgium
+## Copyright (C) 2024-2025 Orthanc Team SRL, Belgium
+## Copyright (C) 2021-2025 Sebastien Jodogne, ICTEAM UCLouvain, Belgium
 ##
 ## This program is free software: you can redistribute it and/or
 ## modify it under the terms of the GNU Affero General Public License
@@ -25,15 +25,17 @@
 cmake_minimum_required(VERSION 2.8)
 project(OrthancPython)
 
-set(PLUGIN_VERSION "4.3")
+set(PLUGIN_VERSION "5.0")
 
 if (PLUGIN_VERSION STREQUAL "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
 else()
-  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.12.4")
+  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.12.6")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
 endif()
+
+include(${CMAKE_SOURCE_DIR}/OrthancSDKVersion.cmake)
 
 
 if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
@@ -181,7 +183,7 @@
     )
 else()
   include_directories(
-    ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Sdk-1.10.0
+    ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Sdk-${ORTHANC_SDK_VERSION}
     )
 endif()

=== debian/changelog ===
orthanc-python (5.0+ds-3) unstable; urgency=medium

  * Team upload.

  [ jodogne-guest ]
  * making d/tests/run-unit-test more strict

  [ Étienne Mollier ]
  * d/control: depend on orthanc >= 1.12.7+dfsg-3.
    The orthanc version needs to be new enough to have built against a
    dcmtk version that reverted versioned dcmtk data directory.
  * d/t/run-unit-test: do not fail on pkill attempts.

 -- Étienne Mollier <emollier@debian.org>  Wed, 23 Apr 2025 22:05:50 +0200

orthanc-python (5.0+ds-2) unstable; urgency=medium

  * Team upload.

  [ Sudip Mukherjee ]
  * Drop unused, and old runtime dependency for test
    against libcurl4 (now renamed in libcurlt64)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 27 Feb 2025 10:18:34 +0100

orthanc-python (5.0+ds-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 24 Feb 2025 18:14:18 +0100

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,16 @@
         -DDEB_VERSION=$(DEB_VERSION) \
         -DPYTHON_VERSION=$(PYTHON_VERSION) \
         -DORTHANC_FRAMEWORK_SOURCE=system \
+        "-DORTHANC_FRAMEWORK_ADDITIONAL_LIBRARIES=boost_filesystem boost_regex boost_thread jsoncpp" \
         -DCMAKE_BUILD_TYPE=None  # The build type must be set to None, see #711515
+
+
+# Automated generation of the "Built-Using" attribute in "d/control"
+# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=989128
+# Adapted from:
+# https://wiki.debian.org/SIMDEverywhere#Approach (Point 6)
+override_dh_gencontrol:
+	dh_gencontrol -- -Vorthancframework:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W liborthancframework-dev)"
 
 override_dh_auto_configure:
 	mkdir Build

=== debian/watch ===
version=4
opts="repacksuffix=+ds,dversionmangle=s/\+ds//g,repack,compression=xz" \
https://orthanc.uclouvain.be/downloads/sources/orthanc-python/index.html OrthancPython-(\d\S*)\.tar\.gz

## orthanc-python 6.0%2Bds

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, python3, orthanc, curl, orthanc-python, procps
Restrictions: needs-sudo, allow-stderr, isolation-container

## orthanc-python 6.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,22 +25,29 @@
 cmake_minimum_required(VERSION 2.8)
 project(OrthancPython)
 
-set(PLUGIN_VERSION "5.0")
+set(PLUGIN_VERSION "6.0")
 
 if (PLUGIN_VERSION STREQUAL "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
 else()
-  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.12.6")
+  set(ORTHANC_FRAMEWORK_DEFAULT_VERSION "1.12.9")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
 endif()
 
-include(${CMAKE_SOURCE_DIR}/OrthancSDKVersion.cmake)
-
+set(ORTHANC_SDK_DEFAULT_VERSION "1.12.9")
+
+# This list must correspond to the content of "./Resources/SyncOrthancFolder.py"
+set(ORTHANC_SDK_AVAILABLE_VERSIONS "1.7.2" "1.10.0" "1.12.6" "1.12.9")
+
+
+#####################################################################
+## Parameters of the build
+#####################################################################
 
 if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
   # The Python version cannot be controlled on OS X (yet)
-  set(PYTHON_VERSION "3.6" CACHE STRING "Version of Python to be used")
+  set(PYTHON_VERSION "3.13" CACHE STRING "Version of Python to be used")
 endif()
 
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
@@ -50,23 +57,32 @@
   set(PYTHON_WINDOWS_USE_RELEASE_LIBS ON CACHE BOOL "Use the release Python libraries when building with Microsoft Visual Studio, even when compiling in _DEBUG mode (set it to OFF if you require linking to a Python debug build)")
 endif()
 
-
-
-# Parameters of the build
+# Generic parameters
 set(STATIC_BUILD OFF CACHE BOOL "Static build of the third-party libraries (necessary for Windows)")
 set(ALLOW_DOWNLOADS OFF CACHE BOOL "Allow CMake to download packages")
 set(ORTHANC_FRAMEWORK_SOURCE "${ORTHANC_FRAMEWORK_DEFAULT_SOURCE}" CACHE STRING "Source of the Orthanc framework (can be \"system\", \"hg\", \"archive\", \"web\" or \"path\")")
 set(ORTHANC_FRAMEWORK_VERSION "${ORTHANC_FRAMEWORK_DEFAULT_VERSION}" CACHE STRING "Version of the Orthanc framework")
 set(ORTHANC_FRAMEWORK_ARCHIVE "" CACHE STRING "Path to the Orthanc archive, if ORTHANC_FRAMEWORK_SOURCE is \"archive\"")
 set(ORTHANC_FRAMEWORK_ROOT "" CACHE STRING "Path to the Orthanc source directory, if ORTHANC_FRAMEWORK_SOURCE is \"path\"")
-set(USE_FRAMEWORK_ORTHANC_SDK OFF CACHE BOOL "Whether to use the SDK from the Orthanc sources (for developers only, to support new features of the SDK that are still pending in the mainline)")
 
 # Advanced parameters to fine-tune linking against system libraries
-set(ORTHANC_FRAMEWORK_STATIC OFF CACHE BOOL "If linking against the Orthanc framework system library, indicates whether this library was statically linked")
-mark_as_advanced(ORTHANC_FRAMEWORK_STATIC)
-
-
-# Download and setup the Orthanc framework
+set(USE_SYSTEM_ORTHANC_SDK ON CACHE BOOL "Use the system-wide version of the Orthanc plugin SDK")
+
+# Generate the documentation about the "ORTHANC_SDK_VERSION" option
+set(tmp "Version of the Orthanc plugin SDK to use, if not using the system version (can be")
+foreach(version IN LISTS ORTHANC_SDK_AVAILABLE_VERSIONS)
+  set(tmp "${tmp} ${version},")
+endforeach()
+set(tmp "${tmp} \"framework\", or \"path\")")
+
+set(ORTHANC_SDK_VERSION "${ORTHANC_SDK_DEFAULT_VERSION}" CACHE STRING "${tmp}")
+set(ORTHANC_SDK_PATH "" CACHE STRING "Path to the orthanc/OrthancCPlugin.h file, if ORTHANC_SDK_VERSION is set to \"path\"")
+
+
+#####################################################################
+## Download and setup the Orthanc framework
+#####################################################################
+
 include(${CMAKE_SOURCE_DIR}/Resources/Orthanc/CMake/DownloadOrthancFramework.cmake)
 
 if (ORTHANC_FRAMEWORK_SOURCE STREQUAL "system")
@@ -81,11 +97,11 @@
 
 else()
   include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkParameters.cmake)
-  
-  #set(ENABLE_MODULE_IMAGES OFF CACHE INTERNAL "")
-  #set(ENABLE_MODULE_JOBS OFF CACHE INTERNAL "")
-  #set(ENABLE_MODULE_DICOM OFF CACHE INTERNAL "")
-  
+
+  set(ENABLE_MODULE_IMAGES OFF CACHE INTERNAL "")
+  set(ENABLE_MODULE_JOBS OFF CACHE INTERNAL "")
+  set(ENABLE_MODULE_DICOM OFF CACHE INTERNAL "")
+
   include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkConfiguration.cmake)
   include_directories(${ORTHANC_FRAMEWORK_ROOT})
 endif()
@@ -93,12 +109,23 @@
 
 include(${CMAKE_SOURCE_DIR}/Resources/Orthanc/Plugins/OrthancPluginsExports.cmake)
 
+
+#####################################################################
+## Configure the Python library
+#####################################################################
 
 include(CheckIncludeFile)
 include(CheckIncludeFileCXX)
 include(CheckIncludeFiles)
 include(CheckLibraryExists)
-include(FindPythonInterp)
+
+if(CMAKE_VERSION VERSION_GREATER "3.11")
+  find_package(Python REQUIRED COMPONENTS Interpreter)
+  set(PYTHON_EXECUTABLE ${Python_EXECUTABLE})
+else()
+  include(FindPythonInterp)
+  find_package(PythonInterp REQUIRED)
+endif()
 
 
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
@@ -159,7 +186,9 @@
       message(FATAL_ERROR "Error while computing the version information: ${Failure}")
     endif()
 
-    set(WINDOWS_RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/Version.rc)
+    list(APPEND AUTOGENERATED_SOURCES
+      ${CMAKE_CURRENT_BINARY_DIR}/Version.rc
+      )
 
   else()
     find_package(PkgConfig REQUIRED)
@@ -177,26 +206,103 @@
 endif()
 
 
-if (USE_FRAMEWORK_ORTHANC_SDK)
-  include_directories(
-    ${ORTHANC_FRAMEWORK_ROOT}/../../OrthancServer/Plugins/Include
+#####################################################################
+## Find the Orthanc SDK
+#####################################################################
+
+if (STATIC_BUILD OR NOT USE_SYSTEM_ORTHANC_SDK)
+  if (ORTHANC_SDK_VERSION STREQUAL "framework")
+    include_directories(${ORTHANC_FRAMEWORK_ROOT}/../../OrthancServer/Plugins/Include)
+    set(ORTHANC_SDK ${ORTHANC_FRAMEWORK_ROOT}/../../OrthancServer/Plugins/Include/orthanc/OrthancCPlugin.h)
+
+  elseif (ORTHANC_SDK_VERSION STREQUAL "path")
+    include_directories(${ORTHANC_SDK_PATH})
+    set(ORTHANC_SDK ${ORTHANC_SDK_PATH}/orthanc/OrthancCPlugin.h)
+
+  else()
+    list(FIND ORTHANC_SDK_AVAILABLE_VERSIONS ${ORTHANC_SDK_VERSION} tmp)
+    if (tmp EQUAL -1)
+      message(FATAL_ERROR "The source distribution of this plugin does not contain Orthanc SDK ${ORTHANC_SDK_VERSION}")
+    endif()
+
+    include_directories(${CMAKE_SOURCE_DIR}/Resources/Orthanc/Sdk-${ORTHANC_SDK_VERSION})
+    set(ORTHANC_SDK ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Sdk-${ORTHANC_SDK_VERSION}/orthanc/OrthancCPlugin.h)
+  endif()
+
+else()
+  find_path(ORTHANC_SDK_SYSTEM_DIR OrthancCPlugin.h
+    /usr/
+    /usr/local/
+    PATH_SUFFIXES include/orthanc
     )
-else()
-  include_directories(
-    ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Sdk-${ORTHANC_SDK_VERSION}
-    )
-endif()
+
+  if (${ORTHANC_SDK_SYSTEM_DIR} STREQUAL "ORTHANC_SDK_SYSTEM_DIR-NOTFOUND")
+    message(FATAL_ERROR "Cannot locate the orthanc/OrthancCPlugin.h header")
+  endif()
+
+  set(ORTHANC_SDK ${ORTHANC_SDK_SYSTEM_DIR}/OrthancCPlugin.h)
+endif()
+
+
+#####################################################################
+## Auto-generate the wrapper
+#####################################################################
+
+set(ORTHANC_CODE_MODEL ${CMAKE_SOURCE_DIR}/Resources/Orthanc/OrthancPluginCodeModel.json)
+
+add_custom_command(
+  OUTPUT
+  ${CMAKE_CURRENT_BINARY_DIR}/orthanc.pyi
+  ${AUTOGENERATED_DIR}/sdk/sdk.cpp
+  ${AUTOGENERATED_DIR}/sdk/sdk.h
+
+  COMMAND
+  ${PYTHON_EXECUTABLE}
+  ${CMAKE_SOURCE_DIR}/CodeAnalysis/GenerateOrthancSDK.py
+  --sdk ${ORTHANC_SDK}
+  --model ${ORTHANC_CODE_MODEL}
+  --target ${AUTOGENERATED_DIR}/sdk/
+
+  COMMAND
+  ${CMAKE_COMMAND} -E copy
+  ${AUTOGENERATED_DIR}/sdk/orthanc.pyi
+  ${CMAKE_CURRENT_BINARY_DIR}/orthanc.pyi
+
+  DEPENDS
+  ${CMAKE_SOURCE_DIR}/CodeAnalysis/
+  ${ORTHANC_SDK}
+  ${ORTHANC_CODE_MODEL}
+  )
+
+list(APPEND AUTOGENERATED_SOURCES
+  ${AUTOGENERATED_DIR}/sdk/sdk.cpp
+  )
+
+add_custom_target(
+  AutogeneratedTarget
+  DEPENDS
+  ${AUTOGENERATED_SOURCES}
+  )
+
+
+
+#####################################################################
+## Build the plugin
+#####################################################################
 
 add_definitions(
   -DHAS_ORTHANC_EXCEPTION=0
   )
 
 include_directories(
+  ${AUTOGENERATED_DIR}/sdk/
+  ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Plugins/
+  ${CMAKE_SOURCE_DIR}/Sources/
   ${PYTHON_INCLUDE_DIRS}
   )
 
 add_library(OrthancPython SHARED
-  Sources/Autogenerated/sdk.cpp
+  ${AUTOGENERATED_SOURCES}
   Sources/DicomScpCallbacks.cpp
   Sources/ICallbackRegistration.cpp
   Sources/IncomingHttpRequestFilter.cpp
@@ -220,39 +326,19 @@
   ${CMAKE_SOURCE_DIR}/Resources/Orthanc/Plugins/OrthancPluginCppWrapper.cpp
   ${BOOST_SOURCES}
   ${JSONCPP_SOURCES}
-  ${WINDOWS_RESOURCES}
-  )
-
-if (CMAKE_COMPILER_IS_GNUCXX)
+  )
+
+if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR
+    CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
   # Don't report warnings about deprecated functions in the Orthanc SDK
   set_source_files_properties(
-    Sources/Autogenerated/sdk.cpp
-    PROPERTIES COMPILE_FLAGS -Wno-deprecated-declarations)
-endif()
-
-target_link_libraries(OrthancPython ${PYTHON_LIBRARIES})
-
-add_definitions(
-  -DPLUGIN_NAME="python"
-  -DPLUGIN_VERSION="${PLUGIN_VERSION}"
-  )
-
-set_target_properties(OrthancPython PROPERTIES 
-  VERSION ${PLUGIN_VERSION} 
-  SOVERSION ${PLUGIN_VERSION}
-  )
-
-configure_file(
-  Sources/Autogenerated/orthanc.pyi
-  ${CMAKE_CURRENT_BINARY_DIR}/orthanc.pyi
-  COPYONLY)
-
-install(
-  TARGETS OrthancPython
-  RUNTIME DESTINATION lib    # Destination for Windows
-  LIBRARY DESTINATION share/orthanc/plugins    # Destination for Linux
-  )
+    ${AUTOGENERATED_DIR}/sdk/sdk.cpp
+    COMPILE_FLAGS -Wno-deprecated-declarations)
+endif()
 
 if (COMMAND DefineSourceBasenameForTarget)
   DefineSourceBasenameForTarget(OrthancPython)
 endif()
+
+add_dependencies(OrthancPython AutogeneratedTarget)
+

=== debian/changelog ===
orthanc-python (6.0+ds-2) unstable; urgency=medium

  * Fix FTBFS with recent versions of CMake. Closes: #1113376

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 01 Sep 2025 14:33:50 +0200

orthanc-python (6.0+ds-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 19 Aug 2025 16:51:39 +0200

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,14 @@
                debhelper-compat (= 13),
                libboost-all-dev,
                libjsoncpp-dev,
-               liborthancframework-dev (>= 1.12.7+dfsg-3),
+               liborthancframework-dev (>= 1.12.9),
                libpython3-dev,
                orthanc-dev,
                python3-dev,
+               python3-pystache,
                pkgconf,
                unzip
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-python
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-python.git
 Homepage: https://orthanc.uclouvain.be/book/plugins/python.html
@@ -23,7 +24,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         orthanc (>= 1.12.7+dfsg-3)
+         ${orthanc:Minimal-Version}
 Built-Using: ${orthancframework:Built-Using}
 Suggests: python3
 Description: Develop plugins for Orthanc using the Python programming language

=== debian/rules ===
--- 
+++ 
@@ -31,7 +31,9 @@
 # Adapted from:
 # https://wiki.debian.org/SIMDEverywhere#Approach (Point 6)
 override_dh_gencontrol:
-	dh_gencontrol -- -Vorthancframework:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W liborthancframework-dev)"
+	dh_gencontrol -- \
+		-Vorthancframework:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W liborthancframework-dev)" \
+		-Vorthanc:Minimal-Version="$(shell dpkg-query -f '$${source:Package} (>= $${source:Version}), ' -W orthanc-dev)"
 
 override_dh_auto_configure:
 	mkdir Build
